<?php
namespace Faturamento\Repositories;

class Venclusoprop extends \Doctrine\ORM\EntityRepository
{
    public function parcelasLinhaProduto($proposta, $versao, $cdlinprop){
        $sql = "SELECT MIN(DTVELUSOPEDP) AS DTVELUSOPEDP
                  FROM VENCLUSOPROP
                 WHERE NRPROPOSFAS  = :P_NRPROPOSFAS
                   AND NRVERPROPFAS = :P_NRVERPROPFAS
                   AND CDLINPPROP   = :P_CDLINPPROP
                   AND NRORG = 1";

        $params = array(
            "P_NRPROPOSFAS"     => $proposta,
            "P_NRVERPROPFAS"    => $versao,
            "P_CDLINPPROP"      => $cdlinprop
        );

        $result = $this->_em->getConnection()->fetchColumn($sql, $params);

        return $result;
    }

    public function parcelasLinhaProdutoAceite($proposta, $versao, $cdlinprop){
        $sql = "SELECT DISTINCT
                   VC.NRPROPOSFAS , VC.NRVERPROPFAS, VC.CDLINPPROP, ROWNUM AS NRPARCELA,
                   VC.DTVELUSOPEDP, TRUNC(VC.VRVELUSOPEDP,2) AS VRVELUSOPEDPP
                FROM
                   VENCLUSOPROP VC
                WHERE
                   (VC.NRPROPOSFAS  = :P_NRPROPOSFAS ) AND
                   (VC.NRVERPROPFAS = :P_NRVERPROPFAS) AND
                   (VC.CDLINPPROP   = :P_CDLINPPROP)
                ORDER BY
                   VC.DTVELUSOPEDP";

        $params = array(
            "P_NRPROPOSFAS"     => $proposta,
            "P_NRVERPROPFAS"    => $versao,
            "P_CDLINPPROP"      => $cdlinprop
        );

        $result = $this->_em->getConnection()->fetchAll($sql, $params);

        return $result;
    }

    public function parcelasLinhaProdutoRecalcular($proposta, $versao, $cdlinprop){
        $sql = "SELECT TO_CHAR(VC.DTVELUSOPEDP, 'DD/MM/YYYY') AS DTVELUSOPEDP,
                       VC.NRPROPOSFAS, ROUND(VC.VRVELUSOPEDP, 2) AS VRVELUSOPEDP,
                       ROWNUM AS NRPARCELA, VC.CDLINPPROP, VC.NRVERPROPFAS
                  FROM (SELECT DTVELUSOPEDP, VRVELUSOPEDP, NRPROPOSFAS,
                               NRVERPROPFAS, CDLINPPROP
                          FROM VENCLUSOPROP
                         WHERE NRPROPOSFAS  = :P_NRPROPOSFAS
                           AND NRVERPROPFAS = :P_NRVERPROPFAS
                           AND CDLINPPROP   = :P_CDLINPPROP
                      ORDER BY DTVELUSOPEDP
                  ) VC
                ORDER BY VC.DTVELUSOPEDP";

        $params = array(
            "P_NRPROPOSFAS"     => $proposta,
            "P_NRVERPROPFAS"    => $versao,
            "P_CDLINPPROP"      => $cdlinprop
        );

        $result = $this->_em->getConnection()->fetchAll($sql, $params);

        return $result;
    }
    
    public function getParcelasNegociarLinhaProduto($proposta, $versao, $cdlinprop){
        $sql = "SELECT
                   VC.NRPROPOSFAS , VC.NRVERPROPFAS, VC.CDLINPPROP,
                   VC.DTVELUSOPEDP, VC.VRVELUSOPEDP, NRORG
                FROM
                   VENCLUSOPROP VC
                WHERE
                   (VC.NRPROPOSFAS  = :P_NRPROPOSFAS ) AND
                   (VC.NRVERPROPFAS = :P_NRVERPROPFAS) AND
                   (VC.CDLINPPROP   = :P_CDLINPPROP)
                ORDER BY
                   VC.DTVELUSOPEDP";

        $params = array(
            "P_NRPROPOSFAS"     => $proposta,
            "P_NRVERPROPFAS"    => $versao,
            "P_CDLINPPROP"      => $cdlinprop
        );

        $result = $this->_em->getConnection()->fetchAll($sql, $params);

        return $result;
    }

    public function getValorTotalParcelasLinhaProduto($proposta, $versao, $cdlinprop){
        $sql = "SELECT SUM(ROUND(VRVELUSOPEDP,2)) AS VRTOTAL
                  FROM VENCLUSOPROP VC
                 WHERE (NRVERPROPFAS = '$versao')
                   AND (NRPROPOSFAS  = '$proposta')
                   AND (CDLINPPROP   = '$cdlinprop')";

        $params = array(
            "P_NRPROPOSFAS"     => $proposta,
            "P_NRVERPROPFAS"    => $versao,
            "P_CDLINPPROP"      => $cdlinprop
        );

        $result = $this->_em->getConnection()->fetchAll($sql, $params);

        return $result;
    }    
}