<?php
namespace Geral\Logic\TabelaPreco;
use Geral\Util\Ambiente;
use Geral\Util\DateUtil;
use Geral\Entities\Itemprebase;
use Indeterminado\Entities\Promoprbase;
use Setforms2\Shared\Registry;

class OperacaoItemPreBase{

    //Registra/Atualiza Item Preço Base
    public static function regItemPreBase($cdprecobase, $cdproduto, $dtinivalipb, $dtfimvalipb, $vriteprebase, $idativo){
        try{
            /** @var $itemprebase Itemprebase */
            $itemprebase = Itemprebase::getObjectByWhere('NRORG = :NRORG AND CDPRODUTO = :CDPRODUTO AND CDPRECOBASE = :CDPRECOBASE', array('NRORG' => Ambiente::getNrorg(), 'CDPRODUTO' => $cdproduto, 'CDPRECOBASE' => $cdprecobase));
            if(!$itemprebase){
				$itemprebase = New Itemprebase();
				$itemprebase->setCdprecobase($cdprecobase);
				$itemprebase->setCdproduto($cdproduto);
				$itemprebase->setDtinivalipb(self::formataData($dtinivalipb));
				$itemprebase->setDtfimvalipb(self::formataData($dtfimvalipb));
				$itemprebase->setVriteprebase($vriteprebase);
				$itemprebase->setIdativo($idativo);
				$itemprebase->setNrorg(Ambiente::getNrorg());
				$itemprebase->setCdoperatzipb(Ambiente::getCdoperador());
				$itemprebase->setDthratzipb(DateUtil::getDataAtual());
				$itemprebase->setDthratzipb(DateUtil::getDataAtual());
				$itemprebase->persist();
            }else{
                $itemprebase->setDtinivalipb(self::formataData($dtinivalipb));
                $itemprebase->setDtfimvalipb(self::formataData($dtfimvalipb));
                $itemprebase->setVriteprebase($vriteprebase);
                $itemprebase->setIdativo($idativo);
                $itemprebase->persist();
            }
            Registry::getEntityManager()->flush();
        }catch(\Exception $e){
            throw $e;
        }
    }

    //Deleta Item Preço Base
    public static function delItemPreBase($cdprecobase, $cdproduto){
        try{
            /** @var $itemprebase Itemprebase */
            $itemprebase = Itemprebase::getObjectByWhere('NRORG = :NRORG AND CDPRODUTO = :CDPRODUTO AND CDPRECOBASE = :CDPRECOBASE', array('NRORG' => Ambiente::getNrorg(), 'CDPRODUTO' => $cdproduto, 'CDPRECOBASE' => $cdprecobase));
            if($itemprebase){
                /** @var $promoprbase Promoprbase */
                $promoprbase = Promoprbase::getObjectsByWhere('NRORG = :NRORG AND CDPRODUTO = :CDPRODUTO AND CDPRECOBASE = :CDPRECOBASE', array('NRORG' => Ambiente::getNrorg(), 'CDPRODUTO' => $cdproduto, 'CDPRECOBASE' => $cdprecobase));
                if($promoprbase){
                    foreach($promoprbase as $promopr){
                        $promopr->delete();
                    }
                }
                $itemprebase->delete();
                Registry::getEntityManager()->flush();
            }
        }catch(\Exception $e){
            throw $e;
        }
    }

    //Formata Data para Inserção/Atualização
    public static function formataData($data){
        if($data){
            if (strlen($data) == 19)
                $data = DateUtil::truncateString($data);
            $data = DateUtil::getDatadeString($data);
            $data = DateUtil::truncateData($data);
        }else $data = null;
        return $data;
    }

}