<?php

require_once 'base/GepTextosolifluxoEntityBase.php';


/**
 * GepTextosolifluxoEntity.
 *
 * @package Entity
 *
 * @author  alessandrobartels
 */
class GepTextosolifluxoEntity extends GepTextosolifluxoEntityBase
{


    const SEM_REGISTRO = 10;


    /**    ok
     * Retorna lista com a parametrizacao de um determinado tipo de fluxo.
     *
     * @param integer $nrorg    Numero da Organizacao.
     * @param integer $tp_fluxo Tipo do fluxo.
     *
     * @throws Exception Caso nao tenha registro.
     *
     * @return Ambigous <boolean, NULL, TkModelEntity>
     */
    public function retornaDadosTextoFluxo($nrorg, $tp_fluxo){
        $dados = GepTextosolifluxo::consultaTextoFluxo($nrorg, $tp_fluxo);

        if (count($dados[0])>0) {
            return $dados;
        }

        throw new Exception(
            'GepTextosoliEntity: Nao ha textos parametrizados para este tipo de fluxo.',
            self::SEM_REGISTRO
        );
    }


    /**
     * Retorna dados de um texto por fluxo de acordo com a sua PK.
     *
     * @param integer $nrorg   Numero da Organizacao.
     * @param integer $nrtexto Codigo do texto.
     *
     * @throws Exception Caso nao exista o codigo informado.
     *
     * @return GepTextosolifluxoEntity
     */
    public function retornaDadosTextoFluxoPk($nrorg, $nrtexto){
        $dados = GepTextosolifluxo::consultaTextoFluxoPk($nrorg, $nrtexto);

        if ($dados instanceof GepTextosolifluxoEntity) {
            return $dados;
        }

        throw new Exception('GepTextosolifluxo: Nao ha registros deste codigo.', self::SEM_REGISTRO);
    }


    /**
     * Gera novo codigo de Texto da solicitacao do tipo de fluxo.
     *
     * @param integer $nrorg Numero da Organizacao.
     *
     * @return $codigo integer
     */
    public static function retornaProxNumeroTextosolifluxo($nrorg){
        $codigo = Novocodigo::geraCodigo($nrorg, 'GEP_TEXTOSOLIFLUXO', 10);
        return $codigo;
    }


}

